Package org.springframework.jmx.export.assembler

# Class MethodNameBasedMBeanInfoAssembler

java.lang.Object
org.springframework.jmx.export.assembler.AbstractMBeanInfoAssembler
org.springframework.jmx.export.assembler.AbstractReflectiveMBeanInfoAssembler
org.springframework.jmx.export.assembler.AbstractConfigurableMBeanInfoAssembler
org.springframework.jmx.export.assembler.MethodNameBasedMBeanInfoAssembler

All Implemented Interfaces:
  `MBeanInfoAssembler`

public class MethodNameBasedMBeanInfoAssembler extends AbstractConfigurableMBeanInfoAssembler
Subclass of `AbstractReflectiveMBeanInfoAssembler` that allows to specify method names to be exposed as MBean operations and attributes. JavaBean getters and setters will automatically be exposed as JMX attributes.

You can supply an array of method names via the `managedMethods` property. If you have multiple beans and you wish each bean to use a different set of method names, then you can map bean keys (that is the name used to pass the bean to the `MBeanExporter`) to a list of method names using the `methodMappings` property.

If you specify values for both `methodMappings` and `managedMethods`, Spring will attempt to find method names in the mappings first. If no method names for the bean are found, it will use the method names defined by `managedMethods`.

Since:
  1.2
Author:
  Juergen Hoeller
See Also:
  - `setManagedMethods(java.lang.String...)`
  - `setMethodMappings(java.util.Properties)`
  - `InterfaceBasedMBeanInfoAssembler`
  - `SimpleReflectiveMBeanInfoAssembler`
  - `MethodExclusionMBeanInfoAssembler`
  - `MBeanExporter`

## Field Summary

### Fields inherited from class org.springframework.jmx.export.assembler.AbstractReflectiveMBeanInfoAssembler

`ATTRIBUTE_OPERATION_VISIBILITY, FIELD_CLASS, FIELD_CURRENCY_TIME_LIMIT, FIELD_DEFAULT, FIELD_DISPLAY_NAME, FIELD_GET_METHOD, FIELD_LOG, FIELD_LOG_FILE, FIELD_METRIC_CATEGORY, FIELD_METRIC_TYPE, FIELD_PERSIST_LOCATION, FIELD_PERSIST_NAME, FIELD_PERSIST_PERIOD, FIELD_PERSIST_POLICY, FIELD_ROLE, FIELD_SET_METHOD, FIELD_UNITS, FIELD_VISIBILITY, ROLE_GETTER, ROLE_OPERATION, ROLE_SETTER`

## Constructor Summary

Constructors
Constructor
Description
`MethodNameBasedMBeanInfoAssembler()`

## Method Summary

Modifier and Type
Method
Description
`protected boolean`
`includeOperation(Method method, String beanKey)`
Allows subclasses to vote on the inclusion of a particular operation.
`protected boolean`
`includeReadAttribute(Method method, String beanKey)`
Allows subclasses to vote on the inclusion of a particular attribute accessor.
`protected boolean`
`includeWriteAttribute(Method method, String beanKey)`
Allows subclasses to vote on the inclusion of a particular attribute mutator.
`protected boolean`
`isMatch(Method method, String beanKey)`
`void`
`setManagedMethods(String... methodNames)`
Set the array of method names to use for creating the management info.
`void`
`setMethodMappings(Properties mappings)`
Set the mappings of bean keys to a comma-separated list of method names.

### Methods inherited from class org.springframework.jmx.export.assembler.AbstractConfigurableMBeanInfoAssembler

`getNotificationInfo, setNotificationInfoMappings, setNotificationInfos`

### Methods inherited from class org.springframework.jmx.export.assembler.AbstractReflectiveMBeanInfoAssembler

`applyCurrencyTimeLimit, applyDefaultCurrencyTimeLimit, createModelMBeanOperationInfo, getAttributeDescription, getAttributeInfo, getClassForDescriptor, getDefaultCurrencyTimeLimit, getOperationDescription, getOperationInfo, getOperationParameters, getParameterNameDiscoverer, isExposeClassDescriptor, isUseStrictCasing, populateAttributeDescriptor, populateMBeanDescriptor, populateOperationDescriptor, setDefaultCurrencyTimeLimit, setExposeClassDescriptor, setParameterNameDiscoverer, setUseStrictCasing`

### Methods inherited from class org.springframework.jmx.export.assembler.AbstractMBeanInfoAssembler

`checkManagedBean, getClassName, getClassToExpose, getClassToExpose, getConstructorInfo, getDescription, getMBeanInfo, getTargetClass`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### MethodNameBasedMBeanInfoAssembler

public MethodNameBasedMBeanInfoAssembler()

## Method Details

### setManagedMethods

public void setManagedMethods(String... methodNames)
Set the array of method names to use for creating the management info. These method names will be used for a bean if no entry corresponding to that bean is found in the `methodMappings` property.

Parameters:
  `methodNames` - an array of method names indicating the methods to use
See Also:
  - `setMethodMappings(java.util.Properties)`

### setMethodMappings

public void setMethodMappings(Properties mappings)
Set the mappings of bean keys to a comma-separated list of method names. The property key should match the bean key and the property value should match the list of method names. When searching for method names for a bean, Spring will check these mappings first.

Parameters:
  `mappings` - the mappings of bean keys to method names

### includeReadAttribute

protected boolean includeReadAttribute(Method method, String beanKey)
Description copied from class: `AbstractReflectiveMBeanInfoAssembler`
Allows subclasses to vote on the inclusion of a particular attribute accessor.

Specified by:
  `includeReadAttribute` in class `AbstractReflectiveMBeanInfoAssembler`
Parameters:
  `method` - the accessor `Method`
  `beanKey` - the key associated with the MBean in the beans map of the `MBeanExporter`
Returns:
  `true` if the accessor should be included in the management interface, otherwise `false`

### includeWriteAttribute

protected boolean includeWriteAttribute(Method method, String beanKey)
Description copied from class: `AbstractReflectiveMBeanInfoAssembler`
Allows subclasses to vote on the inclusion of a particular attribute mutator.

Specified by:
  `includeWriteAttribute` in class `AbstractReflectiveMBeanInfoAssembler`
Parameters:
  `method` - the mutator `Method`.
  `beanKey` - the key associated with the MBean in the beans map of the `MBeanExporter`
Returns:
  `true` if the mutator should be included in the management interface, otherwise `false`

### includeOperation

protected boolean includeOperation(Method method, String beanKey)
Description copied from class: `AbstractReflectiveMBeanInfoAssembler`
Allows subclasses to vote on the inclusion of a particular operation.

Specified by:
  `includeOperation` in class `AbstractReflectiveMBeanInfoAssembler`
Parameters:
  `method` - the operation method
  `beanKey` - the key associated with the MBean in the beans map of the `MBeanExporter`
Returns:
  whether the operation should be included in the management interface

### isMatch

protected boolean isMatch(Method method, String beanKey)